#include "EEPROM.h"

void setup(){
  Serial.setTimeout(100);
  Serial.begin(9600);
}

void loop(){
  float Rf=0;
  
  if(Serial.available()){
    float Rf=Serial.parseFloat(SKIP_WHITESPACE);

    if(Rf==0){
      char R=Serial.read();
    
      if(R=='A'){
        int X=Lire_mem(1023);
      
        X++;
      
        Sauver_mem(1023,X);
      }
      else if(R=='R'){
        Sauver_mem(1023,0);
        Sauver_mem(1022,123);

        Serial.println("Reset");
      }
    }
    else{
      byte i=Lire_mem(1022);

      i=i-1;

      Sauver_mem(1022,i);
      
      if(i==0){
        Sauver_mem_float(0,Rf);

        Serial.println("Memoire pleine");
        return;
      }
      else Sauver_mem_float((4*i),Rf);
      
      Serial.print("Empl. mem.");
      Serial.print("\t");
      Serial.println("Contenu");
      Serial.print(i);
      Serial.print("\t\t");
      Serial.println(Lire_mem_float(4*i));
    }
    
    Serial.println(Lire_mem(1023));
  }
}

byte Lire_mem(int adr){
  byte val=EEPROM.read(adr);
  
  return val;
}

void Sauver_mem(int adr,int val){
  EEPROM.write(adr,val);
}

float Lire_mem_float(int adr){
  union{
    byte octet[4];
    float f;
  }donnee;

  for(int i=0;i<4;i++){
    donnee.octet[i]=EEPROM.read(adr+i);
  }
  
  return donnee.f;
}

unsigned long Sauver_mem_float(int adr,float val){
  union{
    byte octet[4];
    float f;
  }donnee;

  donnee.f=val;

  for(int i=0;i<4;i++){
    EEPROM.write(adr+i,donnee.octet[i]);
  }
}
